JsonReader
Date: 2016-11-03

com.google.gson.stream

## Class JsonReader

- java.lang.Object
- - com.google.gson.stream.JsonReader

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable
  Direct Known Subclasses:
    JsonTreeReader

      public class JsonReader
      extends java.lang.Object
      implements java.io.Closeable

  Reads a JSON (RFC 7159) encoded value as a stream of tokens. This stream includes both literal values (strings, numbers, booleans, and nulls) as well as the begin and end delimiters of objects and arrays. The tokens are traversed in depth-first order, the same order that they appear in the JSON document. Within JSON objects, name/value pairs are represented by a single token.

  ### Parsing JSON

  To create a recursive descent parser for your own JSON streams, first create an entry point method that creates a `JsonReader`.

  Next, create handler methods for each structure in your JSON text. You'll need a method for each object type and for each array type.

  - Within array handling methods, first call `beginArray()` to consume the array's opening bracket. Then create a while loop that accumulates values, terminating when `hasNext()` is false. Finally, read the array's closing bracket by calling `endArray()`.
  - Within object handling methods, first call `beginObject()` to consume the object's opening brace. Then create a while loop that assigns values to local variables based on their name. This loop should terminate when `hasNext()` is false. Finally, read the object's closing brace by calling `endObject()`.

  When a nested object or array is encountered, delegate to the corresponding handler method.

  When an unknown name is encountered, strict parsers should fail with an exception. Lenient parsers should call `skipValue()` to recursively skip the value's nested tokens, which may otherwise conflict.

  If a value may be null, you should first check using `peek()`. Null literals can be consumed using either `nextNull()` or `skipValue()`.

  ### Example

  Suppose we'd like to parse a stream of messages such as the following:

       [
         {
           "id": 912345678901,
           "text": "How do I read a JSON stream in Java?",
           "geo": null,
           "user": {
             "name": "json_newb",
             "followers_count": 41
            }
         },
         {
           "id": 912345678902,
           "text": "@json_newb just use JsonReader!",
           "geo": [50.454722, -104.606667],
           "user": {
             "name": "jesse",
             "followers_count": 2
           }
         }
       ]

  This code implements the parser for the above structure:

         public List<Message> readJsonStream(InputStream in) throws IOException {
           JsonReader reader = new JsonReader(new InputStreamReader(in, "UTF-8"));
           try {
             return readMessagesArray(reader);
           } finally {
             reader.close();
           }
         }

         public List<Message> readMessagesArray(JsonReader reader) throws IOException {
           List<Message> messages = new ArrayList<Message>();

           reader.beginArray();
           while (reader.hasNext()) {
             messages.add(readMessage(reader));
           }
           reader.endArray();
           return messages;
         }

         public Message readMessage(JsonReader reader) throws IOException {
           long id = -1;
           String text = null;
           User user = null;
           List<Double> geo = null;

           reader.beginObject();
           while (reader.hasNext()) {
             String name = reader.nextName();
             if (name.equals("id")) {
               id = reader.nextLong();
             } else if (name.equals("text")) {
               text = reader.nextString();
             } else if (name.equals("geo") && reader.peek() != JsonToken.NULL) {
               geo = readDoublesArray(reader);
             } else if (name.equals("user")) {
               user = readUser(reader);
             } else {
               reader.skipValue();
             }
           }
           reader.endObject();
           return new Message(id, text, user, geo);
         }

         public List<Double> readDoublesArray(JsonReader reader) throws IOException {
           List<Double> doubles = new ArrayList<Double>();

           reader.beginArray();
           while (reader.hasNext()) {
             doubles.add(reader.nextDouble());
           }
           reader.endArray();
           return doubles;
         }

         public User readUser(JsonReader reader) throws IOException {
           String username = null;
           int followersCount = -1;

           reader.beginObject();
           while (reader.hasNext()) {
             String name = reader.nextName();
             if (name.equals("name")) {
               username = reader.nextString();
             } else if (name.equals("followers_count")) {
               followersCount = reader.nextInt();
             } else {
               reader.skipValue();
             }
           }
           reader.endObject();
           return new User(username, followersCount);
         }

  ### Number Handling

  This reader permits numeric values to be read as strings and string values to be read as numbers. For example, both elements of the JSON array `[1, "1"]` may be read using either `nextInt()` or `nextString()`. This behavior is intended to prevent lossy numeric conversions: double is JavaScript's only numeric type and very large values like `9007199254740993` cannot be represented exactly on that platform. To minimize precision loss, extremely large values should be written and read as strings in JSON.

  ### Non-Execute Prefix

  Web servers that serve private data using JSON may be vulnerable to Cross-site request forgery attacks. In such an attack, a malicious site gains access to a private JSON file by executing it with an HTML `<script>` tag.

  Prefixing JSON files with `")]}'\n"` makes them non-executable by `<script>` tags, disarming the attack. Since the prefix is malformed JSON, strict parsing fails when it is encountered. This class permits the non-execute prefix when `lenient parsing` is enabled.

  Each `JsonReader` may be used to read a single JSON stream. Instances of this class are not thread safe.

  Since:
    1.6

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `JsonReader(java.io.Reader in)` Creates a new instance that reads a JSON-encoded stream from `in`.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `beginArray()` Consumes the next token from the JSON stream and asserts that it is the beginning of a new array.
    `void` | `beginObject()` Consumes the next token from the JSON stream and asserts that it is the beginning of a new object.
    `void` | `close()` Closes this JSON reader and the underlying `Reader`.
    `void` | `endArray()` Consumes the next token from the JSON stream and asserts that it is the end of the current array.
    `void` | `endObject()` Consumes the next token from the JSON stream and asserts that it is the end of the current object.
    `java.lang.String` | `getPath()` Returns a JsonPath to the current location in the JSON value.
    `boolean` | `hasNext()` Returns true if the current array or object has another element.
    `boolean` | `isLenient()` Returns true if this parser is liberal in what it accepts.
    `boolean` | `nextBoolean()` Returns the `boolean` value of the next token, consuming it.
    `double` | `nextDouble()` Returns the `double` value of the next token, consuming it.
    `int` | `nextInt()` Returns the `int` value of the next token, consuming it.
    `long` | `nextLong()` Returns the `long` value of the next token, consuming it.
    `java.lang.String` | `nextName()` Returns the next token, a `property name`, and consumes it.
    `void` | `nextNull()` Consumes the next token from the JSON stream and asserts that it is a literal null.
    `java.lang.String` | `nextString()` Returns the `string` value of the next token, consuming it.
    `JsonToken` | `peek()` Returns the type of the next token without consuming it.
    `void` | `setLenient(boolean lenient)` Configure this parser to be liberal in what it accepts.
    `void` | `skipValue()` Skips the next value recursively.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### JsonReader

          public JsonReader(java.io.Reader in)

      Creates a new instance that reads a JSON-encoded stream from `in`.

  - ### Method Detail

    - #### setLenient

          public final void setLenient(boolean lenient)

      Configure this parser to be liberal in what it accepts. By default, this parser is strict and only accepts JSON as specified by RFC 4627. Setting the parser to lenient causes it to ignore the following syntax errors:
      - Streams that start with the non-execute prefix, `")]}'\n"`.
      - Streams that include multiple top-level values. With strict parsing, each stream must contain exactly one top-level value.
      - Top-level values of any type. With strict parsing, the top-level value must be an object or an array.
      - Numbers may be `NaNs` or `infinities`.
      - End of line comments starting with `//` or `#` and ending with a newline character.
      - C-style comments starting with `/*` and ending with `*``/`. Such comments may not be nested.
      - Names that are unquoted or `'single quoted'`.
      - Strings that are unquoted or `'single quoted'`.
      - Array elements separated by `;` instead of `,`.
      - Unnecessary array separators. These are interpreted as if null was the omitted value.
      - Names and values separated by `=` or `=>` instead of `:`.
      - Name/value pairs separated by `;` instead of `,`.

    - #### isLenient

          public final boolean isLenient()

      Returns true if this parser is liberal in what it accepts.

    - #### beginArray

          public void beginArray()
                          throws java.io.IOException

      Consumes the next token from the JSON stream and asserts that it is the beginning of a new array.
      Throws:
        `java.io.IOException`

    - #### endArray

          public void endArray()
                        throws java.io.IOException

      Consumes the next token from the JSON stream and asserts that it is the end of the current array.
      Throws:
        `java.io.IOException`

    - #### beginObject

          public void beginObject()
                           throws java.io.IOException

      Consumes the next token from the JSON stream and asserts that it is the beginning of a new object.
      Throws:
        `java.io.IOException`

    - #### endObject

          public void endObject()
                         throws java.io.IOException

      Consumes the next token from the JSON stream and asserts that it is the end of the current object.
      Throws:
        `java.io.IOException`

    - #### hasNext

          public boolean hasNext()
                          throws java.io.IOException

      Returns true if the current array or object has another element.
      Throws:
        `java.io.IOException`

    - #### peek

          public JsonToken peek()
                         throws java.io.IOException

      Returns the type of the next token without consuming it.
      Throws:
        `java.io.IOException`

    - #### nextName

          public java.lang.String nextName()
                                    throws java.io.IOException

      Returns the next token, a `property name`, and consumes it.
      Throws:
        `java.io.IOException` - if the next token in the stream is not a property name.

    - #### nextString

          public java.lang.String nextString()
                                      throws java.io.IOException

      Returns the `string` value of the next token, consuming it. If the next token is a number, this method will return its string form.
      Throws:
        `java.lang.IllegalStateException` - if the next token is not a string or if this reader is closed.
        `java.io.IOException`

    - #### nextBoolean

          public boolean nextBoolean()
                              throws java.io.IOException

      Returns the `boolean` value of the next token, consuming it.
      Throws:
        `java.lang.IllegalStateException` - if the next token is not a boolean or if this reader is closed.
        `java.io.IOException`

    - #### nextNull

          public void nextNull()
                        throws java.io.IOException

      Consumes the next token from the JSON stream and asserts that it is a literal null.
      Throws:
        `java.lang.IllegalStateException` - if the next token is not null or if this reader is closed.
        `java.io.IOException`

    - #### nextDouble

          public double nextDouble()
                            throws java.io.IOException

      Returns the `double` value of the next token, consuming it. If the next token is a string, this method will attempt to parse it as a double using `Double.parseDouble(String)`.
      Throws:
        `java.lang.IllegalStateException` - if the next token is not a literal value.
        `java.lang.NumberFormatException` - if the next literal value cannot be parsed as a double, or is non-finite.
        `java.io.IOException`

    - #### nextLong

          public long nextLong()
                        throws java.io.IOException

      Returns the `long` value of the next token, consuming it. If the next token is a string, this method will attempt to parse it as a long. If the next token's numeric value cannot be exactly represented by a Java `long`, this method throws.
      Throws:
        `java.lang.IllegalStateException` - if the next token is not a literal value.
        `java.lang.NumberFormatException` - if the next literal value cannot be parsed as a number, or exactly represented as a long.
        `java.io.IOException`

    - #### nextInt

          public int nextInt()
                      throws java.io.IOException

      Returns the `int` value of the next token, consuming it. If the next token is a string, this method will attempt to parse it as an int. If the next token's numeric value cannot be exactly represented by a Java `int`, this method throws.
      Throws:
        `java.lang.IllegalStateException` - if the next token is not a literal value.
        `java.lang.NumberFormatException` - if the next literal value cannot be parsed as a number, or exactly represented as an int.
        `java.io.IOException`

    - #### close

          public void close()
                     throws java.io.IOException

      Closes this JSON reader and the underlying `Reader`.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Throws:
        `java.io.IOException`

    - #### skipValue

          public void skipValue()
                         throws java.io.IOException

      Skips the next value recursively. If it is an object or array, all nested elements are skipped. This method is intended for use when the JSON token stream contains unrecognized or unhandled values.
      Throws:
        `java.io.IOException`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getPath

          public java.lang.String getPath()

      Returns a JsonPath to the current location in the JSON value.